/*
 * Copyright © 2018-2022 Koherence, LLC (www.koherence.com).
 *
 * This file is part of the Entangle ATSC 3.0 Base Stack.
 *
 * The Entangle ATSC 3.0 Base Stack is free software: you can redistribute it
 * and/or modify it under the terms of the GNU Affero General Public License
 * version 3 as published by the Free Software Foundation with the addition of
 * the following permission added to Section 15 as permitted in Section 7(a):
 * FOR ANY PART OF THE COVERED WORK IN WHICH THE COPYRIGHT IS OWNED BY
 * KOHERENCE, LLC, KOHERENCE, LLC DISCLAIMS THE WARRANTY OF NON INFRINGEMENT
 * OF THIRD PARTY RIGHTS.
 *
 * The Entangle ATSC 3.0 Base Stack is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Affero
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write
 * to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * You can contact Koherence, LLC at email address info@koherence.com
 */

#ifndef ENATSC3_H
#define ENATSC3_H

typedef enum
{
    ENATSC3MediaType_Invalid = 0,
    ENATSC3MediaType_Audio = 1,
    ENATSC3MediaType_Video = 2,
    ENATSC3MediaType_Subtitle = 3,
} ENATSC3MediaType;

typedef enum
{
    ENATSC3Codec_Invalid = 0,

    // Video codecs
    ENATSC3Codec_HEV1 = 1,
    ENATSC3Codec_HVC1 = 2,

    // Audio codecs
    ENATSC3Codec_AAC = 32,
    ENATSC3Codec_AC4 = 33,

    // Subtitle codecs
    ENATSC3Codec_TTML = 64,
} ENATSC3Codec;

// Note that these enums come from A/331
typedef enum
{
    ENATSC3SLSProtocol_Reserved = 0,
    ENATSC3SLSProtocol_ROUTE = 1,
    ENATSC3SLSProtocol_MMTP = 2
} ENATSC3SLSProtocol;

#define NANOSECONDS_PER_SECOND  1000000000
#define MICROSECONDS_PER_SECOND 1000000
#define MILLISECONDS_PER_SECOND 1000
#define NANOSECONDS_PER_MILLISECOND (NANOSECONDS_PER_SECOND/MILLISECONDS_PER_SECOND)
#define NANOSECONDS_PER_MICROSECOND (NANOSECONDS_PER_SECOND/MICROSECONDS_PER_SECOND)
#define MICROSECONDS_PER_MILLISECOND (MICROSECONDS_PER_SECOND/MILLISECONDS_PER_SECOND)

#endif
