/*
 * Copyright © 2018-2023 Koherence, LLC (www.koherence.com).
 *
 * This file is part of the Entangle ATSC 3.0 Base Stack.
 *
 * The Entangle ATSC 3.0 Base Stack is free software: you can redistribute it
 * and/or modify it under the terms of the GNU Affero General Public License
 * version 3 as published by the Free Software Foundation with the addition of
 * the following permission added to Section 15 as permitted in Section 7(a):
 * FOR ANY PART OF THE COVERED WORK IN WHICH THE COPYRIGHT IS OWNED BY
 * KOHERENCE, LLC, KOHERENCE, LLC DISCLAIMS THE WARRANTY OF NON INFRINGEMENT
 * OF THIRD PARTY RIGHTS.
 *
 * The Entangle ATSC 3.0 Base Stack is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Affero
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write
 * to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * You can contact Koherence, LLC at email address info@koherence.com
 */

#ifndef ENATSC3_DEMOD_DEFS_H
#define ENATSC3_DEMOD_DEFS_H

typedef enum
{
    ENATSC3Modulation_Unknown = 0,
    ENATSC3Modulation_QPSK = 1,
    ENATSC3Modulation_16QAM = 2,
    ENATSC3Modulation_64QAM = 3,
    ENATSC3Modulation_256QAM = 4,
    ENATSC3Modulation_1024QAM = 5,
    ENATSC3Modulation_4096QAM = 6,
} ENATSC3Modulation;

typedef enum
{
    ENATSC3Coding_Unknown = 0,
    ENATSC3Coding_2_15 = 2,
    ENATSC3Coding_3_15 = 3,
    ENATSC3Coding_4_15 = 4,
    ENATSC3Coding_5_15 = 5,
    ENATSC3Coding_6_15 = 6,
    ENATSC3Coding_7_15 = 7,
    ENATSC3Coding_8_15 = 8,
    ENATSC3Coding_9_15 = 9,
    ENATSC3Coding_10_15 = 10,
    ENATSC3Coding_11_15 = 11,
    ENATSC3Coding_12_15 = 12,
    ENATSC3Coding_13_15 = 13,
} ENATSC3Coding;

#endif
