/*
 * Copyright © 2018-2023 Koherence, LLC (www.koherence.com).
 *
 * This file is part of the Entangle ATSC 3.0 Base Stack.
 *
 * The Entangle ATSC 3.0 Base Stack is free software: you can redistribute it
 * and/or modify it under the terms of the GNU Affero General Public License
 * version 3 as published by the Free Software Foundation with the addition of
 * the following permission added to Section 15 as permitted in Section 7(a):
 * FOR ANY PART OF THE COVERED WORK IN WHICH THE COPYRIGHT IS OWNED BY
 * KOHERENCE, LLC, KOHERENCE, LLC DISCLAIMS THE WARRANTY OF NON INFRINGEMENT
 * OF THIRD PARTY RIGHTS.
 *
 * The Entangle ATSC 3.0 Base Stack is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Affero
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write
 * to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * You can contact Koherence, LLC at email address info@koherence.com
 */

#ifndef ENATSC3SOURCE_DEFS_H
#define ENATSC3SOURCE_DEFS_H

typedef enum
{
    ENATSC3BroadcastSystem_Invalid = 0,
    ENATSC3BroadcastSystem_ATSC10 = 1,
    ENATSC3BroadcastSystem_ATSC30 = 2,
} ENATSC3BroadcastSystem;

typedef enum
{
    ENATSC3SourceType_Invalid = 0,
    ENATSC3SourceType_ALPFile = 1,
    ENATSC3SourceType_BasebandFile = 2,
    ENATSC3SourceType_PCAPFile = 3,
    ENATSC3SourceType_BasebandRZRSDK2 = 4,
    ENATSC3SourceType_J288ALPHDHR = 5,
} ENATSC3SourceType;

typedef ENStatus (*ENATSC3SourceWriteCallback)(uint8_t *pBytes, int32_t nBytes, 
    void *pUserData);

// A convenience macro for all file-based devices
#define ENATSC3SourceType_File (ENATSC3SourceType_ALPFile | ENATSC3SourceType_BasebandFile | ENATSC3SourceType_PCAPFile)

typedef struct
{
    uint64_t tuid;
    char strModel[32];
    char strSerial[32];
    char strName[32];
} ENATSC3SourceDescription;

#endif
