/*
 * Copyright © 2018-2022 Koherence, LLC (www.koherence.com). 
 *
 * This file is part of the Entangle ATSC 3.0 Base Stack.
 *
 * The Entangle ATSC 3.0 Base Stack is free software: you can redistribute it
 * and/or modify it under the terms of the GNU Affero General Public License
 * version 3 as published by the Free Software Foundation with the addition of 
 * the following permission added to Section 15 as permitted in Section 7(a): 
 * FOR ANY PART OF THE COVERED WORK IN WHICH THE COPYRIGHT IS OWNED BY 
 * KOHERENCE, LLC, KOHERENCE, LLC DISCLAIMS THE WARRANTY OF NON INFRINGEMENT 
 * OF THIRD PARTY RIGHTS.
 *
 * The Entangle ATSC 3.0 Base Stack is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Affero
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License 
 * along with this program; if not, see http://www.gnu.org/licenses or write 
 * to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, 
 * Boston, MA 02110-1301 USA.
 *
 * You can contact Koherence, LLC at email address info@koherence.com
 */

#ifndef ENATSC3ROUTE_SLS_ROUTEMIME_H
#define ENATSC3ROUTE_SLS_ROUTEMIME_H

typedef struct
{
    const char *pContentType;
    int32_t contentTypeLen;

    struct
    {
        const char *pName;
        int32_t nameLen;
        const char *pValue;
        int32_t valueLen;
    } vParameters[16];
    int32_t nParameters;
} ENATSC3ROUTESLSMultipartMIMEHeaderInfo_t;

typedef int32_t (*ENATSC3ROUTESLS_ROUTEMIME_XMLDocumentCallback)(
    const char *pDocument, int32_t sDocument, const char *pPart, int32_t sPart, 
    char *pContentType, char *pContentLocation, void *pUserData);

ENStatus
ENATSC3ROUTESLSMultipartMIMEHeaderParse(const char *pXMLIn, int32_t sXMLIn,
    ENATSC3ROUTESLSMultipartMIMEHeaderInfo_t *pInfo, 
    const char **ppFirstPartStart, int32_t *pNBytesRemaining);

ENStatus
ENATSC3ROUTESLSMultipartMIMEPartsParse(const char *pXML, int32_t sXML,
    const char *pBoundary, int32_t boundaryLen,
    ENATSC3ROUTESLS_ROUTEMIME_XMLDocumentCallback XMLDocumentCallback,
    void *pUserData);

#endif
