/*
 * Copyright © 2023-2023 Koherence, LLC (www.koherence.com).
 *
 * This file is part of the Entangle ATSC 3.0 Base Stack.
 *
 * The Entangle ATSC 3.0 Base Stack is free software: you can redistribute it
 * and/or modify it under the terms of the GNU Affero General Public License
 * version 3 as published by the Free Software Foundation with the addition of
 * the following permission added to Section 15 as permitted in Section 7(a):
 * FOR ANY PART OF THE COVERED WORK IN WHICH THE COPYRIGHT IS OWNED BY
 * KOHERENCE, LLC, KOHERENCE, LLC DISCLAIMS THE WARRANTY OF NON INFRINGEMENT
 * OF THIRD PARTY RIGHTS.
 *
 * The Entangle ATSC 3.0 Base Stack is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Affero
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write
 * to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * You can contact Koherence, LLC at email address info@koherence.com
 */

#ifndef LIBENUTILS_CRC32C_H
#define LIBENUTILS_CRC32C_H

#if defined(_MSC_VER) || defined(__x86_64__) || defined(__i386__)
#define ENUtils_crc32c ENUtils_crc32c_sse4
#else
#define ENUtils_crc32c ENUtils_crc32c_sw
#endif

uint32_t ENUtils_crc32c_sw(uint32_t crc, void const *buf, size_t len);
uint32_t ENUtils_crc32c_sse4(uint32_t crc, void const *buf, size_t len);

#endif // LIBENUTILS_CRC32C_H
