/*
 * Copyright © 2022 Koherence, LLC (www.koherence.com).
 * 
 * This file is part of the Entangle ATSC 3.0 Base Stack.
 *
 * The Entangle ATSC 3.0 Base Stack is free software: you can redistribute it
 * and/or modify it under the terms of the GNU Affero General Public License
 * version 3 as published by the Free Software Foundation with the addition of
 * the following permission added to Section 15 as permitted in Section 7(a):
 * FOR ANY PART OF THE COVERED WORK IN WHICH THE COPYRIGHT IS OWNED BY
 * KOHERENCE, LLC, KOHERENCE, LLC DISCLAIMS THE WARRANTY OF NON INFRINGEMENT
 * OF THIRD PARTY RIGHTS.
 *
 * The Entangle ATSC 3.0 Base Stack is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Affero
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write
 * to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * You can contact Koherence, LLC at email address info@koherence.com
 */

#ifndef LIBENUTILS_DEFS_STATUS_H
#define LIBENUTILS_DEFS_STATUS_H

typedef enum
{
    ENStatus_Success = 0,
    ENStatus_Failure = 1,
    ENStatus_OutOfRange = 2,
    ENStatus_Dropped = 3,
    ENStatus_NotSupported = 4,
    ENStatus_InvalidData = 5,
    ENStatus_NotFound = 6,
    ENStatus_Retry = 7,
    ENStatus_EOF = 8,
    ENStatus_Timeout = 9,
    ENStatus_NotReady = 10,
    ENStatus_Orphaned = 11,
    ENStatus_Conflict = 12,
    ENStatus_Restart = 13,
    ENStatus_Abort = 14,
    ENStatus_ResourceNotAvailable = 15,
    ENStatus_ResourceNotFound = 16,
    ENStatus_BufferTooSmall = 17,
    ENStatus_Quiescing = 18,
    ENStatus_Incomplete = 19,
    ENStatus_Initializing = 20,
    ENStatus_InvalidRecording = 21,
    ENStatus_RecordingInProgress = 22,
    ENStatus_Exiting = 23,
    ENStatus_NoTSSource = 24,
    ENStatus_AlreadyScanning = 25,
    ENStatus_Gone = 26,

    // database statuses
    ENStatus_ObjectNotInDatabase = 32,
    ENStatus_EndOfResults = 33,
    ENStatus_MultipleObjects = 34,
    ENStatus_DependentObjectNotInDatabase = 35,
    ENStatus_DatabaseConnectionLost = 36,

    // tssource tsatuses
    ENStatus_TooManyTuners = 48,

    // Recording Container statuses
    ENStatus_ContainerFull = 128,
    ENStatus_EndOfFile = 129,
    ENStatus_AlreadyExists = 130,
    ENStatus_ReadAtLive = 131,
    ENStatus_RepairNeeded = 132,
    ENStatus_SeekToTimeBeforeContainerStart = 133,
    ENStatus_SeekToTimeAnchorBeforeContainerStart = 134,
    ENStatus_SeekToTimeNoAnchors = 135,

} ENStatus;

#endif
